Dir   = fullfile(toolboxdir('vision'), 'visiondata','characters');
trainingSet = imageSet(Dir,  'recursive');

img = read(trainingSet(3), 4);

% Extract HOG features and HOG visualization
%[hog_2x2, vis2x2] = extractHOGFeatures(img,'CellSize',[2 2]);
[hog_4x4, vis4x4] = extractHOGFeatures(img,'CellSize',[4 4]);
%[hog_8x8, vis8x8] = extractHOGFeatures(img,'CellSize',[8 8]);

% Show the original image
%figure;
%subplot(2,3,1:3); imshow(img);

% Visualize the HOG features
%subplot(2,3,4);
%plot(vis2x2); 
%title({'CellSize = [2 2]'; ['Feature length = ' num2str(length(hog_2x2))]});

%subplot(2,3,5);
%plot(vis4x4);
%title({'CellSize = [4 4]'; ['Feature length = ' num2str(length(hog_4x4))]});

%subplot(2,3,6);
%plot(vis8x8);
%title({'CellSize = [8 8]'; ['Feature length = ' num2str(length(hog_8x8))]});

cellSize = [4 4];
hogFeatureSize = length(hog_4x4);

trainingFeatures = [];
trainingLabels   = [];

for character = 1:numel(trainingSet)

    numImages = trainingSet(character).Count;
    features  = zeros(numImages, hogFeatureSize, 'single');

    for i = 1:numImages

        img = read(trainingSet(character), i);
        features(i, :) = extractHOGFeatures(img, 'CellSize', cellSize);
        
    end

    
    labels = repmat(trainingSet(character).Description, numImages, 1);

    trainingFeatures = [trainingFeatures; features];   
    trainingLabels   = [trainingLabels;   labels  ];   

end

classifier = fitcecoc(trainingFeatures, trainingLabels);

srcFiles = dir('*.Bmp');  % the folder in which ur images exists
fd = fopen('result.txt','w');
for i = 1 : 6220
    filename = srcFiles(i).name;
    I = imread(filename);
    testfeatures = zeros(1, hogFeatureSize, 'single');
    testfeatures = extractHOGFeatures(I, 'CellSize', cellSize);
    predictedLabel = predict(classifier, testfeatures);
    fprintf(fd,'%s\t%s\n',filename,predictedLabel);
end
 fclose(fd);
